##############################################################################
#
# Author: Logan Mancuso
# Created: 11.27.2023
#
##############################################################################

resource "proxmox_virtual_environment_time" "tz" {
  for_each  = var.nodes
  node_name = each.value.name
  time_zone = "America/New_York"
}

# Cert Management #
# Request Cert from CA #
resource "tls_cert_request" "node_cert_request" {
  for_each        = var.nodes
  private_key_pem = tls_private_key.datacenter.private_key_pem
  dns_names = [
    "${each.value.ip}",
    "${each.value.name}",
    "${each.value.name}.local"
  ]
  subject {
    common_name  = "${local.cert_root.subject.common_name} Datacenter"
    organization = local.cert_root.subject.organization
    country      = local.cert_root.subject.country
    locality     = local.cert_root.subject.locality
    postal_code  = local.cert_root.subject.postal_code
    province     = local.cert_root.subject.province
  }
}

# Issue Node Intermediate Cert #
resource "tls_locally_signed_cert" "node" {
  for_each           = var.nodes
  cert_request_pem   = tls_cert_request.node_cert_request[each.key].cert_request_pem
  ca_private_key_pem = local.cert_root.private
  ca_cert_pem        = local.cert_root.cert
  set_subject_key_id = true

  validity_period_hours = 365
  early_renewal_hours   = 36

  allowed_uses = [
    "key_encipherment",  # Permission for key encipherment
    "digital_signature", # Permission for digital signature
    "cert_signing",      # Permission to sign certificates
    "client_auth",       # Permission for client authentication
    "server_auth"        # Permission for server authentication
  ]
}
resource "proxmox_virtual_environment_certificate" "node_cert" {
  for_each    = var.nodes
  node_name   = each.value.name
  certificate = tls_locally_signed_cert.node[each.key].cert_pem
  private_key = tls_private_key.datacenter.private_key_pem
}

### Bootstrap Node ###
locals {
  directories = {
    home = "/opt/tofu"
    log  = "/var/log/tofu"
  }
}

# you need to use username password over ssh key here, the bootstrap copies the ssh key to the target node
resource "terraform_data" "bootstrap_node" {
  for_each         = var.nodes
  triggers_replace = [md5(file("${path.module}/scripts/bootstrap.sh"))]
  # Make default directories on the Node
  provisioner "remote-exec" {
    when   = create
    inline = [for key, dirs in local.directories : "mkdir --parents ${dirs}"]
    connection {
      type     = "ssh"
      user     = local.credentials_proxmox.username
      password = local.credentials_proxmox.password
      host     = each.value.ip
    }
  }
  # Copy Helper Scripts to Target Node
  provisioner "file" {
    when        = create
    source      = "${path.module}/scripts/helper"
    destination = local.directories.home
    connection {
      type     = "ssh"
      user     = local.credentials_proxmox.username
      password = local.credentials_proxmox.password
      host     = each.value.ip
    }
  }
  # Copy Bootstrap Script
  provisioner "file" {
    when = create
    content = templatefile("${path.module}/scripts/bootstrap.sh",
      {
        log         = "${local.directories.log}/bootstrap.log"
        node_name   = each.value.name
        pool        = each.value.zfs_pool
        smtp_server = local.credentials_smtp.host
        smtp_port   = local.credentials_smtp.port
        smtp_user   = local.credentials_smtp.username
        smtp_pass   = local.credentials_smtp.password
        email_from  = "${each.value.name}@${var.networks["cluster"].subdomain}.${var.domain_name}"
        email_to    = local.credentials_smtp.username
        id          = each.key
        ## each of these keys are used for a different purpose ##
        # authorized_key, private key is held by the developer and used to ssh into the physical proxmox node
        authorized_key = local.credentials_proxmox.sshkey_public
        # instance_key, keys are generated by global secrets and used to remote into virtual instances
        # a copy of the private key is installed onto the proxmox node as well as the developers machine for ssh
        instance_key = local.credentials_proxmox.sshkey_instance_private
        # resources_key, is generated by global secrets and the private key will be installed on proxmox nodes and virtual instances
        # the public key will be published on hosted platforms like gitlab to pull private snippets and other private resources
        resources_key = local.credentials_proxmox.sshkey_resource_private
      }
    )
    destination = "${local.directories.home}/bootstrap.sh"
    connection {
      type     = "ssh"
      user     = local.credentials_proxmox.username
      password = local.credentials_proxmox.password
      host     = each.value.ip
    }
  }
  # Execute Bootstrap Script
  provisioner "remote-exec" {
    when = create
    inline = [
      "chmod u+x,g+x ${local.directories.home}/bootstrap.sh",
      "${local.directories.home}/bootstrap.sh"
    ]
    connection {
      type     = "ssh"
      user     = local.credentials_proxmox.username
      password = local.credentials_proxmox.password
      host     = each.value.ip
    }
  }
}
